#ifndef LIST_H
#define LIST_H

#include <stdbool.h>
#include "list_elm.h"

typedef struct list {
	list_elm_t * head, * tail;
	int numelm;
} list_t;

list_t * new_list();
void del_list ( list_t * * L, void (*ptrf) () );
bool empty_list ( list_t * L );

list_elm_t * get_head ( list_t * L );
list_elm_t * get_tail ( list_t * L );
void view_list ( list_t * L, void (*ptrf)() );

void cons ( list_t * L, void * data );
void queue ( list_t * L, void * data );
void ordered_insert ( list_t * L, void * data, int (*cmpFct)() );