#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "db.h"
#include "list.h"
#include "list_elm.h"

list_t * read_list( file_mode_t mode, void * (*read_fct) (), void (*del_fct) () ) {
	FILE * fd;
	char fname[20];
	list_t * L = new_list();
	
	if (mode == TEXT) {// Open file in TEXT mode
		printf( "\t\tRead list from text file (.txt)\n\tfile name :" );
		scanf( "%s", fname );
		fd = fopen( fname, "rt" );
	}
	else {// open file in BIN mode
		printf( "\t\tRead list from binary file (.bin)\n\tfile name :" );
		scanf( "%s", fname );
		fd = fopen( fname, "rb" );
	}
	//todo
	void * datum;
	while ((datum = read_fct(fd, mode)) != NULL) {
		queue(L, datum);
	}

	
	list_elm_t * E = get_tail(L);
	if (E != NULL && empty_list(E->data)) {
		list_elm_t * T = get_pred(E);
		if (T != NULL) {
			set_suc(T, NULL);
			L->tail = T;
		} else {
			L->head = L->tail = NULL;
		}
		del_list_elm(&E, del_fct);
	}

		/** TODO parcourir le fichier pour y collecter les formulaires et les ranger dans la L
			ATTENTION :
				il est **possible** que vous créiez un élément de trop (un formulaire vide) en fin de liste.
				Il faut alors penser à le supprimer grâce au code suivant :
					E = get_tail (L);
					struct elmlist * T = getPred(E);
					set_suc(T, NULL);
					L->tail = T;
					del_elmlist(E, ptr_del);
		*/

		
		fclose(fd);
		return L;
	}
void write_list( list_t * L, file_mode_t mode, void (*write_fct) () ) {
	FILE * fd;
	char fname[20];
	if (mode == TEXT) {
		printf( "\t\tWrite list to text file (.txt)\n\tfile name :"), scanf( "%s", fname );
		fd = fopen( fname, "wt" );
	} else {
		printf("\t\tWrite list to binary file (.bin)\n\tfile name :"), scanf( "%s", fname );
		fd = fopen(fname, "wb" );
	}	
		
		for (list_elm_t * elm = get_head(L); elm != NULL; elm = elm->next){
			write_fct(elm->data, mode, fd);
		}
	/// @todo Parcourir L et écrire les formulaires grâce à data_write_fct
	fclose(fd);
}

